// Precalculate the mod 26 value of each character.

#include <stdio.h>
#include <string.h>

#include "text.h"

const char* const keys[] =
{
/*  1 */ "EUJGZBBEIKUVQFQCGKNQ", // L8  (KEY)   //  1
/*  1 */ "JBFCEGMQREYHBVHNLVZP", // L13         //  2
/*  2 */ "DUJJTWNDXAGTBKMJVTMD", // L11         //  3
/*  3 */ "VMHOKWMIZWKZTJDYFKSG", // L1          //  4
/*  4 */ "EKSYCFHEQTWUBEBTELCO", // L13 (KEY)   //  5
/*  5 */ "XBNVKXBPNGCYQSIUPJLV", // L5  (KEY)   //  6
/*  6 */ "KJYQKGAWZYAGVEJVKGUK", // L2          //  7
/*  7 */ "IVYIZJJOLFOGQOPJJEXY", // L14 (KEY)   //  8
/*  7 */ "EGEQOIOTFADVVJNNSGDL", // L5          //  9
/*  8 */ "ZGTEVNDRXKOSNHIHAEMU", // L3          // 10
/*  9 */ "TFRQAMYUWOLXKTDNBHIW", // L1          // 11
/* 10 */ "CPMVGKHPMEGPIDHQFJDF", // L9          // 12
/* 11 */ "WYTAPRVJHYHUJLTUTMVZ", // L5  (KEY)   // 13
/* 11 */ "JLIFDEPEKIUTCRBLWRLG", // L10         // 14
/* 12 */ "BKXKWEBUZOXSZCIFLAYC", // L7          // 15
/* 13 */ "PPRBIMCYJVRLKVXPUUGF", // L11         // 16
	 "HMTFSDTGQJCIAZLDDCWB",                // 17
	 "APYHZHJMCWURMHPFWVIK",                // 18
	 "JQQZOZRUZPZRQSHBUQJE",                // 19
	 "FZYMVFQGZOKDLJMIMPGQ",                // 20
	 "HTJXDUFPLITWUYLCLTSO",                // 21
};


char* expand( const unsigned char* b )
{
  static char buf[20];
  int i;

  for (i = 0; i < 4; ++i)
    sprintf( buf + i * 4, "00%.2x", b[3-i] );

  return buf;
}


int main( int argc, char* argv[] )
{
  int page, line, n, N;
  union
  {
    unsigned n;
    unsigned char c[20];
  } m;
  const char* text;
  int i, wrap;

  printf( "const int lengths[PAGES][LINES] =\n{\n" );
  for (page = 0; page < 13; ++page)
  {
    printf( "  {" );
    for (line = 0; line < 16; ++line)
    {
      printf( "%3d", (int)strlen( pages[page][line] ) );
      if (line != 15) putchar( ',' );
    }
    printf( " },\n" );
  }
  printf( "};\n\n" );

  printf( "const DWVECTOR keys[COUNTERS][KEYS] =\n{\n" );
  for (N = 0; N < 20; ++N)
  {
    if (N == 0) printf( "  {\n" );
    for (line = 0; line < 21; ++line)
    {
      memset( m.c, 0, sizeof(m.c) );
      n = N;
      for (text = keys[line]; *text; ++text)
      {
	m.c[n] = (m.c[n] + *text) % 26;
	if (++n == 20)
	  n = 0;
      }
      printf( "    { 0x%s, { ", expand( m.c ) );
      for (n = 4; n < 20; ++n)
      {
	if (n != 4)
	  putchar( ',' );
	printf( "%2d", m.c[n] );
      }
      printf( " } },\n" );
    }
    printf( N == 19 ? "  }\n" : "  }, {\n" );
  }
  printf( "};\n\n" );

  printf( "const DWVECTOR pages[COUNTERS][PAGES][LINES] =\n{\n" );
  for (N = 0; N < 20; ++N)
  {
    if (N == 0) printf( "  {\n" );
    for (page = 0; page < 13; ++page)
    {
      if (page == 0) printf( "    {\n" );
      for (line = 0; line < 16; ++line)
      {
	memset( m.c, 0, sizeof(m.c) );
	n = N;
	wrap = 0;
	for (text = pages[page][line]; *text; ++text)
	{
	  m.c[n] = (m.c[n] + *text) % 26;
	  if (++n == 20)
	  {
	    wrap = 1;
	    n = 0;
	  }
	}
	printf( "    { 0x%s, { ", expand( m.c ) );
	if (wrap)
	  n = 20;
	for (i = 4; i < n; ++i)
	{
	  if (i != 4)
	    putchar( ',' );
	  printf( "%2d", m.c[i] % 26 );
	}
	printf( "%*c} },\n", (20 - n) * 3 + 1, ' ' );
      }
      printf( page == 12 ? "    }\n" : "    }, {\n" );
    }
    printf( N == 19 ? "  }\n" : "  }, {\n" );
  }
  printf( "};\n" );

  return 0;
}
